"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");
var _pureUuid = _interopRequireDefault(require("pure-uuid"));
var _es = _interopRequireDefault(require("aggregation/es6"));
var _gts1Version = _interopRequireDefault(require("./gts-1-version"));
var _gts2UtilHook = _interopRequireDefault(require("./gts-2-util-hook"));
var _gts3UtilGraphql = _interopRequireDefault(require("./gts-3-util-graphql"));
var _gts4UtilSequelizeOptions = _interopRequireDefault(require("./gts-4-util-sequelize-options"));
var _gts5UtilSequelizeFields = _interopRequireDefault(require("./gts-5-util-sequelize-fields"));
var _gts6UtilFts = _interopRequireDefault(require("./gts-6-util-fts"));
var _gts7EntityQuery = _interopRequireDefault(require("./gts-7-entity-query"));
var _gts8EntityCreate = _interopRequireDefault(require("./gts-8-entity-create"));
var _gts9EntityClone = _interopRequireDefault(require("./gts-9-entity-clone"));
var _gtsAEntityUpdate = _interopRequireDefault(require("./gts-A-entity-update"));
var _gtsBEntityDelete = _interopRequireDefault(require("./gts-B-entity-delete"));
/*
**  GraphQL-Tools-Sequelize -- Integration of GraphQL-Tools and Sequelize ORM
**  Copyright (c) 2016-2023 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/*  external dependencies  */

/*  internal dependencies  */

/*  the API class  */
class GraphQLToolsSequelize extends (0, _es.default)(_gts1Version.default, _gts2UtilHook.default, _gts3UtilGraphql.default, _gts4UtilSequelizeOptions.default, _gts5UtilSequelizeFields.default, _gts6UtilFts.default, _gts7EntityQuery.default, _gts8EntityCreate.default, _gts9EntityClone.default, _gtsAEntityUpdate.default, _gtsBEntityDelete.default) {
  constructor(sequelize, options = {}) {
    super(sequelize, options);
    this._sequelize = sequelize;
    this._models = sequelize.models;
    this._idname = typeof options.idname === "string" ? options.idtype : "id";
    this._idtype = typeof options.idtype === "string" ? options.idtype : "UUID";
    this._idmake = typeof options.idmake === "function" ? options.idmake : () => new _pureUuid.default(1).format();
    this._hcname = typeof options.hcname === "string" ? options.hctype : "hc";
    this._hctype = typeof options.hctype === "string" ? options.hctype : "UUID";
    this._hcmake = typeof options.hcmake === "function" ? options.hcmake : data => new _pureUuid.default(5, "ns:URL", `uri:gts:${data}`).format();
    this._anonCtx = function (type) {
      this.__$type$ = type;
    };
    this._anonCtx.prototype.isType = function (type) {
      return this.__$type$ === type;
    };
  }
  boot() {
    return this._ftsBoot();
  }
}

/*  export the traditional way for interoperability reasons
    (as Babel would export an object with a 'default' field)  */
module.exports = GraphQLToolsSequelize;
